   /****************************************************************
    maintuser

    (C) Bernard Pidoux f6bvp - august 2009

    based on FBB tool program "maintinf" by

    F6FBB - Jean-Paul ROUBELAT
    6, rue George Sand
    31120 - Roquettes - France
	jpr@f6fbb.org

    Copyright (C) 1986-2000 by F6FBB
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Parts of code have been taken from many other softwares.
    Thanks for the help.
    ****************************************************************/
#undef DEBUG
#define ENGLISH

#ifdef DEBUG 
#define dprintf() printf()
#endif

#include "version.h"
#include "fbb_conf.h"

#ifdef __LINUX__

#include <math.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <syslog.h>
#include <stdarg.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define __NO_CTYPE
#define __a2__ __attribute__ ((packed, aligned(2)))

#else

#define __a2__

#include <stdio.h>
#include <ctype.h>
#include <time.h>

#endif

#define INF_TXT "inf.txt"
#define INF_NEW "inf.new"
#define INF_SYS "inf.sys"
#define FALSE 0
#define TRUE  1
#define VERSION "beta-1"

#define uchar unsigned char
#define ushort unsigned short
#define EXCLUDED(buf) (buf.flags & 0x1)

void dprintf(const char * format, ...);

void dprintf(const char * format, ...) 
{
}


typedef struct typindic
{
	char call[7];
	char num;
}
indicat;

typedef struct
{
	indicat indic;				/* 8  Callsign */
	indicat relai[8];			/* 64 Digis path */
	long lastmes __a2__;			/* 4  Last L number */
	long nbcon __a2__;			/* 4  Number of connexions */
	long hcon __a2__;			/* 4  Last connexion date */
	long lastyap __a2__;			/* 4  Last YN date */
	ushort flags;				/* 2  Flags */
	ushort on_base;				/* 2  ON Base number */

	uchar nbl;				/* 1  Lines paging */
	uchar lang;				/* 1  Language */

	long newbanner __a2__;			/* 4  Last Banner date */
	ushort download;			/* 2  download size (KB) = 100 */
	char free[20];				/* 20 Reserved */
	char theme;				/* 1  Current topic */

	char nom[18];				/* 18 1st Name */
	char prenom[13];			/* 13 Christian name */
	char adres[61];				/* 61 Address */
	char ville[31];				/* 31 City */
	char teld[13];				/* 13 home phone */
	char telp[13];				/* 13 modem phone */
	char home[41];				/* 41 home BBS */
	char qra[7];				/* 7  Qth Locator */
	char priv[13];				/* 13 PRIV directory */
	char filtre[7];				/* 7  LC choice filter */
	char pass[13];				/* 13 Password */
	char zip[9];				/* 9  Zipcode */

}
info;							/* Total : 360 bytes */

typedef struct typindictri
{
	char indic[7];
	long pos;
	struct typindictri *suiv;
}
indictri;

FILE *fichi, *ficho;
char temp[500];
char system_dir[256];
indictri *tete;
int rejet, nbindic;
int ext_call = 0;

/*static void debogue (FILE *fichi, FILE * ficho);*/
static void defauts (void);
static int find (char *s);
static void check (info * bul);
static void err_alloc (void);
static void insere (char *ind, long pos);
static void ouvre_nomenc (char *);


#ifdef __LINUX__
char *strupr (char *txt)
{
	char *scan = txt;

	while (*scan)
	{
		if (islower (*scan))
			*scan = toupper (*scan);
		++scan;
	}

	return (txt);
}

char *strlwr (char *txt)
{
	char *scan = txt;

	while (*scan)
	{
		if (isupper (*scan))
			*scan = tolower (*scan);
		++scan;
	}

	return (txt);
}
#endif

char *test_back_slash (char *chaine)
{
	if ((strlen(chaine) == 0)
#ifdef __LINUX__
		|| (chaine[strlen (chaine) - 1] != '/'))
			strcat(chaine, "/");
#else
		|| (chaine[strlen (chaine) - 1] != '\\'))
			strcat(chaine, "\\");
#endif
	return (chaine);
}

void err_keyword(char *keyword)
{
	fprintf(stderr, "Error : keyword \"%s\"missing in fbb.conf file\n", keyword);
	exit(1);
}

void epure (char *ligne)
{
	int lg;

	lg = strlen (ligne);
	if (ligne[lg - 1] == '\n')
		ligne[lg - 1] = '\0';
	lg = strlen (ligne);
	if (ligne[lg - 1] == '\r')
		ligne[lg - 1] = '\0';
	if (*ligne == '\032')
		*ligne = '\0';
}

/*
void debogue (FILE *fichi, FILE *ficho)
{
char buffer [512];
int n, k=1;
char *j; 
	
	printf ("\n\n");
	while (!feof(fichi)) {
		j = fgets(buffer, 8, fichi);
		for (n=0; n< 8; n+=8) {
			printf("(%03d) %02X %02X %02X %02X %02X %02X %02X ",k, buffer[n], buffer[n+1], buffer[n+2],buffer[n+3],buffer[n+4],buffer[n+5],buffer[n+6]);	
			printf("*%c %c %c %c %c %c %c* ",buffer[n], buffer[n+1], buffer[n+2],buffer[n+3],buffer[n+4],buffer[n+5],buffer[n+6]);	
			printf("*%02d %02d %02d %02d %02d %02d %02d* \n",buffer[n], buffer[n+1], buffer[n+2],buffer[n+3],buffer[n+4],buffer[n+5],buffer[n+6]);
		k+=7;
		}
	}
}
*/

int main (int argc, char **argv)
{
	FILE *fd;
	int rep;
	int k,m,n;
	int auto_rep = 0;
	int monthes;
	info buf;
	long rinfo = 0;
	indictri *ptr;
	long temps = time (NULL);
	long timout;
	char filename[128];
	static char item[128];
	char buffer[256];
	char *j;

#ifdef LETTRE
	fprintf (stdout, "\nMAINTUSER v %d.%02d%c %s by f6bvp\n", MAJEUR, MINEUR, LETTRE, VERSION);
#else
	fprintf (stdout, "\nMAINTUSER v %d.%02d %s by f6bvp\n", MAJEUR, MINEUR, VERSION);
#endif
	fprintf (stdout, "\nUsage : \"maintuser\"         transcripts valid FBB user records into text file\n");
	fprintf (stdout, "        \"maintuser inf.txt\" transcripts user info text file back into local dir inf.sys\n\n");
	fprintf (stdout, "Note : FBB daemon must be stopped before replacing original inf.sys\n\n");
/*
#ifdef ENGLISH
	fprintf (stderr, "FBB software MUST be stopped !!    \n\n");
#else
	fprintf (stderr, "Le logiciel FBB Doit etre arr�t� !!\n\n");
#endif
*/
	defauts ();

	rejet = nbindic = 0;
	timout = 86400L * 31L;		/* 31 jours / mois */

      	if (argc == 2)
	{

/* D'abord ouvrir le fichier texte d'info user FBB INF.TXT */

	fd = fopen(argv[1], "rt") ;
	if (fd == NULL) {
#ifdef FRANCAIS
	  printf("\nFichier texte '%s' user info FBB non trouv�\n",argv[1]);
#else
	  printf("\nFBB user info text file '%s' not found\n",argv[1]);
#endif
	exit(1);
	}	

	sprintf (filename, "%s", INF_SYS);
	if ((ficho = fopen (filename, "wb")) == NULL)
	{
#ifdef ENGLISH
	    fprintf (stderr, "Error creating %s     \n", filename);
#else
	    fprintf (stderr, "Impossible de creer %s\n", filename);
#endif
	exit(1);
	}	

/*  transcrition du fichier texte dans base de données INF.SYS */

	strcpy(item, "");
	for (n=0; n<127; n++)
		strcat (item,"");
	item[127]='\0';

/*
 * Ecrit base de données users dans INF.SYS 
 */
	while (!feof(fd)) {

	/* Get user call */
			buffer[0]='\0';
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			if (j <= 0) break;
			k = sscanf(buffer, "%7s", buf.indic.call);
			buf.indic.call[6] = '\0';
	/* Get user ssid */
	   		j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%d", &m);
			buf.indic.num = (char)m;
			printf("*%s* ", buf.indic.call);
			printf("*%d*\n", buf.indic.num);		
	/* Get 8 relays calls */
			for (n = 0; n < 8; n++) {
				j = fgets(buffer, 256, fd);
				dprintf("buffer =%s=\n", buffer);
				k = sscanf(buffer, "%7s", buf.relai[n].call);
				if (strncmp (buf.relai[n].call, "#", 1) == 0) {
					strncpy(buf.relai[n].call, item, 7);
					buf.relai[n].call[6] = '\0';
				}
	/* Get 8 relays ssids */
				j = fgets(buffer, 256, fd);
				dprintf("buffer =%s=\n", buffer);
				if (buf.relai[n].call[0] == '\0') {
					buf.relai[n].num = '\0';
				}
				else {
					k = sscanf(buffer, "%d", &m);
					buf.relai[n].num = (char)m;
				}
				printf("*%s* ", buf.relai[n].call);
				printf("*%d*\n", buf.relai[n].num);
			}
	/*last L number */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%ld", (long*)&buf.lastmes);
			printf("Last L number *%ld*\n", buf.lastmes);
	/*number of connexions*/
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);
			k = sscanf(buffer, "%ld", (long *)&buf.nbcon);
			printf("Number connexions *%ld*\n", buf.nbcon);
	/*Last connexion date */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%ld", (long*)&buf.hcon);
			printf("Last connexion *%ld*\n", buf.hcon);
	/* Last YN date */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%ld", (long*)&buf.lastyap);
			printf("Last YN date *%ld*\n", buf.lastyap);
	/*Flags */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%hu", (ushort*)&buf.flags);
			printf("Flags *%u*\n", buf.flags);
	/*On base */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%hu", (ushort*)&buf.on_base);
			printf("On base *%u*\n", buf.on_base);
	/*Line paging */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%d", &n);
			buf.nbl = (uchar)n;
			printf("Line paging *%d*\n", buf.nbl);
	/* Language */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%d", &n);
			buf.lang = (uchar) n;
			printf("Language *%d*\n", buf.lang);
	/* Last banner date */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%ld", (long*)&buf.newbanner);
			printf("Last banner date *%ld*\n", buf.newbanner);
	/* Kb downloaded */
			j = fgets(buffer, 256, fd);
			dprintf("%s\n", buffer);
			k = sscanf(buffer, "%hu", (ushort*)&buf.download);
			printf("Kb downloaded *%u*\n", buf.download);
	/* Free = Reserved space */
			j = fgets(buffer, 256, fd);
			dprintf("%s\n", buffer);
		 	strncpy(buf.free, item, 20);
			buf.free[19] = '\0';
			printf("Reserved space *%20s*\n", buf.free);
	/* Current topic */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%d", &n);
			buf.theme = (char)n;
			printf("Current theme *%d*\n", buf.theme);
	/* First Name */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%16s", buf.nom);
			if (strncmp (buf.nom, "#", 1) == 0) {
				strncpy (buf.nom, item, 18);
				buf.nom[17] = '\0';
			}
			printf("First Name *%s*\n", buf.nom);
	/* Christian name */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%12s", buf.prenom);
			if (strncmp (buf.prenom, "#", 1) == 0) { 
				strncpy (buf.prenom, item, 13);
				buf.prenom[12] = '\0';
			}
			printf("Christian Name *%s*\n", buf.prenom);
	/* Address */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%61s", buf.adres);
			if (strncmp (buf.adres, "#", 1) == 0) {
				strncpy(buf.adres, item, 61);
				buf.adres[60] = '\0';
			}
			printf("Address *%s*\n", buf.adres);
	/* City */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%31s", buf.ville);
			if (strncmp (buf.ville, "#", 1) == 0) {
				strncpy(buf.ville, item, 31);
				buf.ville[30] = '\0';
			}
			printf("City *%s*\n", buf.ville);
	/* Home phone */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%13s", buf.teld);
			if (strncmp (buf.teld, "#", 1) == 0) {
				strncpy(buf.teld, item, 13);
				buf.teld[12] = '\0';
			}
			printf("Home phone *%s*\n", buf.teld);
	/* Modem phone */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%13s", buf.telp);
			if (strncmp (buf.telp, "#", 1) == 0) {
				strncpy(buf.telp, item, 13);
				buf.telp[12] = '\0';
			}
			printf("Modem phone *%s*\n", buf.telp);
	/* Home */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%41s", buf.home);
			if (strncmp (buf.home, "#", 1) == 0) {
				strncpy(buf.home, item, 41);
				buf.home[40] = '\0';
			}
			printf("Home BBS *%s*\n", buf.home);
	/* QRA */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%7s", buf.qra);
			if (strncmp (buf.qra, "#", 1) == 0) {
				strncpy(buf.qra, item, 7);
				buf.qra[6] = '\0';
			}
			printf("QTH loc *%s*\n", buf.qra);
	/* Private directory */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%13s", buf.priv);
			if (strncmp (buf.priv, "#", 1) == 0) {
				strncpy(buf.priv, item, 13);
				buf.priv[12] = '\0';
			}
			printf("Private directory *%s*\n", buf.priv);
	/* filter */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%7s", buf.filtre);
			if (strncmp (buf.filtre, "#", 1) == 0) { 
				strncpy(buf.filtre, item, 7);
				buf.filtre[6] = '\0';
			}
			printf("Filter *%s*\n", buf.filtre);
	/* Pass */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%13s", buf.pass);
			if (strncmp (buf.pass, "#", 1) == 0) {
				strncpy(buf.pass, item, 13);
				buf.pass[12] = '\0';
			}
			printf("Password *%s*\n", buf.pass);
	/* ZIP */
			j = fgets(buffer, 256, fd);
			dprintf("buffer =%s=\n", buffer);	
			k = sscanf(buffer, "%9s", buf.zip);
			if (strncmp (buf.zip, "#", 1) == 0) {
				strncpy(buf.zip, item, 9);
				buf.zip[8] = '\0';
			}
			printf("Zip *%s*\n\n", buf.zip);

	/* Write a user record */			
		if (feof(fd)) break;
			else {
			check (&buf);
		    	if ((rep = fwrite (&buf, sizeof (buf), 1, ficho)) <= 0) {
#ifdef ENGLISH
			fprintf (stderr, "Error writing on %s     \n", filename);
#else
			fprintf (stderr, "Impossible d'ecrire dans %s\n", filename);
#endif
			exit (1);
			}
		}
	 }    /* while (!feof(fd)); tant que pas fin de fichier */
	
	fclose(fd);
	fclose(ficho);
	
#ifdef ENGLISH
		printf ("New FBB user info data base '%s' created\n", filename);
		printf ("You may now copy this file into '%s' directory\n\n", system_dir);
	
#else
		printf ("Nouvelle base de donn�es Users FBB '%s' cr��e\n", filename);
		printf ("Vous devez recopier ce fichier dans le r�pertoire '%s' cr��e\n\n", system_dir);
#endif
	return 0;
	}

/*
	if (ac == 1)
	{
#ifdef ENGLISH
		fprintf (stderr, "Format : MAINTUSER Monthes [/A]\n\nMonthes is \"time check\" to kill old callsigns (0 = no check)     \n                 \n");
#else
		fprintf (stderr, "Format : MAINTUSER Mois [/A]\n\nMois est le \"Test des dates\" pour supprimer les indicatifs obsoletes\n(0 = pas de test)\n");
#endif
		exit (0);
	}

	monthes = atoi (av[1]);
*/
	monthes = 0;
	timout *= monthes;
/*
	if (ac >= 3)
	{
		ext_call = (strcmp (strupr (av[2]), "/N") == 0);
		if (ext_call)
		{
			--ac;
			++av;
#ifdef ENGLISH
			printf ("No callsign check      \n");
#else
			printf ("Pas de test d'indicatif\n");
#endif
		}
	}

	if (ac == 3)
		auto_rep = (strcmp (strupr (av[2]), "/A") == 0);

#ifdef ENGLISH
	if (monthes)
		printf ("Time check : %d monthes\n", monthes);
	else
		printf ("No Time check    \n");
#else
	if (monthes)
		printf ("Test dates : %d mois   \n", monthes);
	else
		printf ("Pas de test dates\n");
#endif
	sleep (2);
*/
	sprintf (filename, "%s%s", system_dir, INF_SYS);
	ouvre_nomenc (filename);

	if ((tete = (indictri *) malloc (sizeof (indictri))) == NULL)
		err_alloc ();
	tete->suiv = NULL;
	rewind (fichi);
	while ((rep = fread ((char *) &buf, (int) sizeof (buf), 1, fichi)) != 0)
	{
		if ((!EXCLUDED (buf)) && (timout) && ((temps - buf.hcon) > timout))
		{
#ifdef ENGLISH
			printf ("rejects <%s> : Old callsign    \n", buf.indic.call);
#else
			printf ("rej�te <%s> : Indicatif inusit�\n", buf.indic.call);
#endif
			++rejet;
		}
		else if (find (buf.indic.call))
		{
			insere (buf.indic.call, rinfo);
		}
		else
		{

#ifdef ENGLISH
			printf ("rejects <%s> : Incorrect callsign\n", buf.indic.call);
#else
			printf ("rej�te <%s> : Indicatif incorrect\n", buf.indic.call);
#endif
			++rejet;
		}
		++rinfo;
	}

#ifdef ENGLISH
	printf ("\n%d callsigns ok      \n", nbindic);
	printf ("%d callsigns rejected\n", rejet);
/*	printf ("user record size : %d\n", (int)sizeof(buf));*/
/*	printf ("---------------------------------------------\n\n");*/
#else
	printf ("\n%d indicatifs inse�re�s\n", nbindic);
	printf ("%d indicatifs rejete�s\n", rejet);
/*	printf ("taille fiche utilisateur : %d\n", (int)sizeof(buf));*/
/*	printf ("----------------------------------           \n\n");*/
#endif

auto_rep = TRUE;
/*
	if (!auto_rep)
	{
		while (TRUE)
		{
#ifdef ENGLISH
			fprintf (stderr, "Create %s      (Y/N) : ", INF_NEW);
#else
			fprintf (stderr, "Creation de %s (O/N) : ", INF_NEW);
#endif
			rep = getchar ();
#ifdef ENGLISH
			if ((rep == 'y') || (rep == 'Y') || (rep == 'n') || (rep == 'N'))
#else
			if ((rep == 'o') || (rep == 'O') || (rep == 'n') || (rep == 'N'))
#endif
				break;
		}
		putchar ('\n');
	}
*/

rep = 'Y';

#ifdef ENGLISH
	if ((auto_rep) || (toupper (rep) == 'Y'))
	{
#else
	if ((auto_rep) || (toupper (rep) == 'O'))
	{
#endif
	sprintf (filename, "%s%s", system_dir, INF_NEW);
	if ((ficho = fopen (filename, "wb")) == NULL) {
#ifdef ENGLISH
			fprintf (stderr, "Error creating %s     \n", filename);
#else
			fprintf (stderr, "Impossible de creer %s\n", filename);
#endif
	exit(1);
	}
		ptr = tete;
			while ((ptr = ptr->suiv) != NULL)
			{
				fseek (fichi, ptr->pos * (long) sizeof (buf), 0);
				rep = fread (&buf, sizeof (buf), 1, fichi);
				check (&buf);
				rep = fwrite (&buf, sizeof (buf), 1, ficho);
/*
				if ((++i % 10) == 0)
#ifdef ENGLISH
					fprintf (stderr, "\r%ld callsigns  ", i);
#else
					fprintf (stderr, "\r%ld indicatifs ", i);
#endif
*/
			}
/*
#ifdef ENGLISH
			fprintf (stderr, "\r%ld callsigns  ", i);
#else
			fprintf (stderr, "\r%ld indicatifs ", i);
#endif
*/
/*			fclose (ficho);*/
			fputc ('\r', stderr);

#ifdef ENGLISH
		printf ("\nFile %s created\n\n", filename);
/*		printf ("\nYou must now change %s with %s !!\n", INF_SYS, INF_NEW);
		printf ("---------------------------------------------\n\n");*/
#else
		printf ("\nFichier %s cr��\n\n", filename);
		/*printf ("\nRemplacer %s par %s !!           \n", INF_SYS, INF_NEW);
		printf ("----------------------------------           \n\n");*/
#endif
	}
/*	rewind (fichi);
	printf ("\nStructure of original file INF.SYS\n");
	debogue (fichi, ficho);*/
	fclose (fichi);
	fclose (ficho);

/*	if (!auto_rep)
	{
		while (TRUE)
		{
*/
#ifdef ENGLISH
		/*fprintf (stderr, "Transcript user data base into text file '%s'      (Y/N) : ", INF_TXT);*/
		fprintf (stderr, "Transcript user data base %s into text file '%s'\n", filename, INF_TXT);
#else
/*			fprintf (stderr, "Transcription de la base de donnees utilisateur en fichier texte '%s' (O/N) : ", INF_TXT);*/
			fprintf (stderr, "Transcription de la base de donnees utilisateur %s en fichier texte '%s'\n", filename, INF_TXT);
#endif
/*			rep = getchar ();
#ifdef ENGLISH
			if ((rep == 'y') || (rep == 'Y') || (rep == 'n') || (rep == 'N'))
#else
			if ((rep == 'o') || (rep == 'O') || (rep == 'n') || (rep == 'N'))
#endif
				break;
		}
		putchar ('\n');

	}
#ifdef ENGLISH
	if ((auto_rep) || (toupper (rep) == 'Y'))
	{
#else
	if ((auto_rep) || (toupper (rep) == 'O'))
	{
#endif
*/
		sprintf (filename, "%s%s", system_dir, INF_NEW);
		ouvre_nomenc (filename);
		sprintf (filename, "%s", INF_TXT);
		if ((ficho = fopen (filename, "wt")) == NULL)
		{
#ifdef ENGLISH
			fprintf (stderr, "Error creating %s     \n", filename);
#else
			fprintf (stderr, "Impossible de creer %s\n", filename);
#endif
		}
		else
		{
			ptr = tete;
			while ((ptr = ptr->suiv) != NULL)
			{
				fseek (fichi, ptr->pos * (long) sizeof (buf), 0);
				rep = fread (&buf, sizeof (buf), 1, fichi);
				sprintf (item, "%7s\t# User callsign\t#\n", buf.indic.call);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%02d\t# User ssid\t#\n", buf.indic.num);
				rep = fwrite (&item, strlen (item), 1, ficho);
				for (n = 0; n < 8; n++) {
				  sprintf (item, "%7s\t# Relay %d callsign\t#\n", buf.relai[n].call, n+1);	  
				  rep = fwrite (&item, strlen (item), 1, ficho);
				  sprintf (item, "%02d\t# Relay %d ssid\t#\n", buf.relai[n].num, n+1);	  
				  rep = fwrite (&item, strlen (item), 1, ficho);
				}
				sprintf (item, "%ld\t# Last L number\t#\n", buf.lastmes);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%ld\t# Number of connexions\t#\n", buf.nbcon);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%ld\t# Last connexion date\t#\n", buf.hcon);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%ld\t# Last YN date\t#\n", buf.lastyap);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%hu\t# Flags\t#\n", buf.flags);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%hu\t# ON Base number\t#\n", buf.on_base);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%u\t# Lines paging\t#\n", buf.nbl);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%u\t# Language\t#\n", buf.lang);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%ld\t# Last Banner date\t#\n", buf.newbanner);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%u\t# download size (KB)\t#\n", buf.download);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%20s\t# Reserved space\t#\n", buf.free);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%u\t# Current topic\t#\n", buf.theme);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%18s\t# First Name\t#\n", buf.nom);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%13s\t# Christian Name\t#\n", buf.prenom);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%61s\t# Address\t#\n", buf.adres);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%31s\t# City\t#\n", buf.ville);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%13s\t# Home phone\t#\n", buf.teld);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%13s\t# Modem phone\t#\n", buf.telp);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%41s\t# Home BBS\t#\n", buf.home);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%7s\t# QTH locator\t#\n", buf.qra);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%13s\t# PRIV directory\t#\n", buf.priv);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%7s\t# LC choice filter\t#\n", buf.filtre);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%13s\t# Password\t#\n", buf.pass);
				rep = fwrite (&item, strlen (item), 1, ficho);
				sprintf (item, "%9s\t# Zipcode\t#\n", buf.zip);
				rep = fwrite (&item, strlen (item), 1, ficho);


			}
/*			fclose (ficho);*/
			fputc ('\r', stderr);
		}
#ifdef ENGLISH
		printf ("\nTexte file '%s' created\n\n", filename);
		
#else
		printf ("\nFichier texte '%s' cr��\n\n", filename);
#endif
/* Print binary records */
/*	printf ("\nDEBUG : INF.NEW structure\n");
	rewind (fichi);
	debogue (fichi, ficho);	*/
	fclose (fichi);
	fclose (ficho);

	return 0;
}

static void check (info * bul)
{
	int i;

	bul->indic.call[6] = '\0';
	for (i = 0; i < 8; i++)
		bul->relai[i].call[6] = '\0';
	bul->nom[17] = '\0';
	bul->free[19] = '\0';
	bul->prenom[12] = '\0';
	bul->adres[60] = '\0';
	bul->ville[30] = '\0';
	bul->teld[12] = '\0';
	bul->telp[12] = '\0';
	bul->home[40] = '\0';
	bul->qra[6] = '\0';
	bul->priv[12] = '\0';
	bul->filtre[6] = '\0';
	bul->pass[12] = '\0';
	bul->zip[8] = '\0';

	if ((bul->nbcon < 0) || (bul->nbcon > 100000L))
		bul->nbcon = 0L;
	if ((bul->nbl < (uchar) 4) || (bul->nbl > (uchar) 50))
		bul->nbl = (uchar) 25;
	if (bul->lang > (uchar) 99)
		bul->lang = (uchar) 1;
}


static void insere (char *ind, long pos)
{
	int cmp;
	indictri *pprec, *ptr, *ptemp;

	pprec = ptr = tete;
	while ((ptr = ptr->suiv) != NULL)
	{
		cmp = strcmp (ind, ptr->indic);
		if (cmp == 0)
		{
			printf ("rejects <%s> : already inserted\n", ind);
			++rejet;
			return;
		}
		else if (cmp < 0)
			break;
		pprec = ptr;
	}
	if ((ptemp = (indictri *) malloc (sizeof (indictri))) == NULL)
		err_alloc ();

	++nbindic;
	ptemp->suiv = ptr;
	pprec->suiv = ptemp;
	ptemp->pos = pos;
	strcpy (ptemp->indic, ind);
/* Prints callsign */
	printf ("(%02d) %s\n", nbindic, ind);
}


static int find (char *s)
{
	char *t = s;
	int n = 0;
	int dernier = 0, chiffre = 0, lettre = 0;

	while (*t)
	{
		if (!isalnum (*t))
			return (FALSE);
		*t = toupper (*t);

		dernier = (isdigit (*t));

		if (isdigit (*t))
			++chiffre;
		else
			++lettre;

		++t;
		++n;
	}

	/*
	   * L'indicatif doit avoir entre 3 et 6 caracteres .
	   *             doit contenir 1 ou 2 chiffres .
	   *             ne doit pas se terminer par un chiffre .
	 */

	if (ext_call)
	{
		/*
		 * L'indicatif doit avoir entre 3 et 6 caracteres .
		 *             doit contenir au moins un chiffre
		 *                  doit contenir au moins une lettre
		 */
		if ((n < 3) || (n > 6) || (chiffre < 1) || (lettre < 1))
			return (0);
	}
	else
	{
		/*
		   * L'indicatif doit avoir entre 3 et 6 caracteres .
		   *             doit contenir 1 ou 2 chiffres .
		   *             ne doit pas se terminer par un chiffre .
		 */

		if ((n < 3) || (n > 6) || (chiffre < 1) || (chiffre > 2) || dernier)
			return (0);
	}

	t = temp;
	while (isalnum (*s))
		*t++ = *s++;
	*t = '\0';
	t = temp;
	return (TRUE);
}


static void ouvre_nomenc (char * filename)
{
/*	char filename[256];

	sprintf (filename, "%s%s", system_dir, INF_SYS);*/
	if ((fichi = fopen (filename, "rb")) == NULL)
	{
#ifdef ENGLISH
		fprintf (stderr, "Cannot find %s !!     \n", filename);
#else
		fprintf (stderr, "Erreur ouverture %s !!\n", filename);
#endif
		exit (1);
	}
}


static void err_alloc (void)
{
#ifdef ENGLISH
	fprintf (stderr, "Memory allocation error  \n");
#else
	fprintf (stderr, "Erreur allocation memoire\n");
#endif
	exit (1);
}

static void defauts (void)
{
	unsigned int flag;
	char *ptr;
	char temp[20];

	if (read_fbb_conf(NULL) > 0)
	{
#ifdef ENGLISH
		fprintf (stdout, "Cannot open fbb.conf file        \n");
#else
		fprintf (stdout, "Erreur ouverture fichier fbb.conf\n");
#endif
		exit (1);				/* and users base directory */
	}

	ptr = find_fbb_conf("vers", 0);
	if (ptr == NULL)
	{
#ifdef ENGLISH
		fprintf (stdout, "Version number missing in fbb.conf\n");
#else
		fprintf (stdout, "Pas de num�ro dans le fbb.conf\n");
#endif
		exit (1);
	}

	sprintf (temp, "FBB%d.%02d", MAJEUR, MINEUR);
	if (strncasecmp (temp, ptr, 7) != 0)
	{
#ifdef ENGLISH
		fprintf (stdout, "Wrong version number in fbb.conf\n");
#else
		fprintf (stdout, "Num�ro de version erron� dans fbb.conf\n");
#endif
		exit (1);
	}
	fprintf (stdout, "Configuration version : %s\n\n", ptr);

	/* path of conf files */
	ptr = find_fbb_conf("data", 0);
	if (ptr == NULL)
		ptr = def_fbb_conf("data");
	if (ptr == NULL)
		err_keyword("data");
	strcpy (system_dir, test_back_slash(strlwr (ptr)));

	/* flags */
	ptr = find_fbb_conf("fbbf", 0);
	if (ptr == NULL)
		ptr = def_fbb_conf("fbbf");
	if (ptr == NULL)
		err_keyword("fbbf");
	flag = 0;
	sscanf (ptr, "%s %u", temp, &flag);
	ext_call = ((flag & 4096) != 0);
}
